package Email;

use strict;

my $default_from = '"Spotter at lightandmatter.com" <no-reply@lightandmatter.com>';

# send_email(TO=> , FROM=> , SUBJECT=> , BODY=>)
# FROM can be omitted, in which case it defaults to the $default_from address.
# To be polite, FROM should be of the form
#   "realname" <x@y>
# TO can be either a single address (scalar) or
# a reference to an array of addresses, to which the
# mail will be sent one at a time.

sub send_email {
  my %args = (
    FROM=>$default_from,
    @_,
  );
  my $to = $args{'TO'};
  my $from = $args{'FROM'};
  my $subject = $args{'SUBJECT'};
  my $body = $args{'BODY'};


  my @recipients = ();
  if (ref $to) {
    @recipients = @$to;
  }
  else {
    if ($to eq '') {return}
    push @recipients,$to;
  }

  my $err = '';

  foreach my $recipient(@recipients) {
    $err = $err . send_an_email($recipient,$from,$subject,$body);
  } # end loop over recipients

  return $err;
} # end send_mail()

sub syntactically_valid {
  my $addy = shift;
  if ($addy eq '') {return 0}
  return ($addy =~ m/.+\@.+\..+/);
}

sub send_email_from_student {
  my $from_username = shift;
  my $from_email = shift;
  my $from_name = shift;
  my $to_email = shift;
  my $link = shift;
  my $body = shift; # is null if not ready to send yet
  my $subject1 = shift;
  my $subject2 = shift;

  #print "link=$link,body=$body,sub1=$subject1,sub2=$subject2";

  $subject1 = "$subject1: ";

  my $from = '"'.$from_name.'"'." <$from_email>";
  my $from_html = '"'.$from_name.'"'." &lt;$from_email&gt;";

  my $subject = $subject1.$subject2;
  my $sent = 0;
  if ($body ne '') {
    my $err = send_an_email($to_email,$from,$subject,$body);
    if ($err eq '') {
      print "<p>Your e-mail has been sent.</p>\n";
      $sent = 1;
    }
    else {
      print "<p>Error: $err</p>\n";
    }
  }

  if (!$sent) {
  print '<form method="POST" action="'.$link.'">'."\n";
  print "<table>\n";
  print "<tr><td>From:</td><td>$from_html</td></tr>\n";
  print "<tr><td>To:</td><td>$to_email</td></tr></table>\n";
  print "<tr><td>Subject:</td><td>$subject1";
  print '<input type="text" name="emailSubject" size="50" maxlength="50" value="'.$subject2.'">';
  print "</td></tr>\n";
  print '<tr><td colspan="2">'."\n";
  print '<textarea name="emailBody" rows="30" cols="100">';
  print $body;
  print "</textarea><br/>\n";
  print '<input type="submit" name="submitEmailButton" value="Send">'."\n";
  print "</td></tr>\n";
  print "</table>\n";
  print "</form>\n";
  }

  if ($sent) {
  print "<table>\n";
  print "<tr><td>From:</td><td>$from_html</td></tr>\n";
  print "<tr><td>To:</td><td>$to_email</td></tr></table>\n";
  print "<tr><td>Subject:</td><td>$subject";
  print "</td></tr>\n";
  print '<tr><td colspan="2">'."\n";
  print "<p>".$body."</p>";
  print "</td></tr>\n";
  print "</table>\n";
  }

}

sub send_an_email {
      my $to = shift;
      my $from = shift;
      my $subject = shift;
      my $body = shift;

    my $message = <<END_OF_MESSAGE;
To: $to
From: $from
Subject: $subject

$body
END_OF_MESSAGE

      my $err = '';

      if (syntactically_valid($to)) {
        my $result = open MAIL, "| sendmail -t";
        if ($result) {
          print MAIL $message;
          close MAIL;
        }
        else {
          $err = "error opening pipe to sendmail";
        }
      } # end if valid address
      else {
        $err = "email not sent to address -$to-, not a syntactically valid email address\n";
      }
      return $err;
}

1;
